Index: unk/anuga_core/source/anuga/LICENSE.txt
===================================================================
--- /trunk/anuga_core/source/anuga/LICENSE.txt	(revision 8815)
+++ 	(revision )
@@ -1,54 +1,0 @@
-=======================================	
-ANUGA Hydrodynamic Inundation Modelling
-=======================================	
-
-
-Copyright 2004, 2005, 2006, 2007, 2008, 2009, 2010 Australian National University and Geoscience Australia. All rights reserved.
-
-
-Permission to use, copy, modify, and distribute this software for any
-purpose without fee is hereby granted under the terms of the GNU
-General Public License as published by the Free Software Foundation;
-either version 2 of the License, or (at your option) any later
-version, provided that this entire notice is included in all copies
-of any software which is or includes a copy or modification of this
-software and in all copies of the supporting documentation for such
-software.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License (http://www.gnu.org/copyleft/gpl.html)
-for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
-
-
-
-This work was produced at Geoscience Australia and the Australian
-National University funded by the Commonwealth of Australia. Neither
-the Australian Government, the Australian National University,
-Geoscience Australia nor any of their employees, makes any warranty,
-express or implied, or assumes any liability or responsibility for
-the accuracy, completeness, or usefulness of any information,
-apparatus, product, or process disclosed, or represents that its use
-would not infringe privately-owned rights. Reference herein to any
-specific commercial products, process, or service by trade name,
-trademark, manufacturer, or otherwise, does not necessarily
-constitute or imply its endorsement, recommendation, or favoring by
-the Australian Government, Geoscience Australia or the Australian
-National University.  The views and opinions of authors expressed
-herein do not necessarily state or reflect those of the Australian
-Government, Geoscience Australia or the Australian National
-University, and shall not be used for advertising or product
-endorsement purposes.
-
-
-This document does not convey a warranty, express or implied,
-of merchantability or fitness for a particular purpose.
-
-
-
-
Index: unk/anuga_core/source/anuga/README.txt
===================================================================
--- /trunk/anuga_core/source/anuga/README.txt	(revision 8815)
+++ 	(revision )
@@ -1,69 +1,0 @@
-This is the root-Subversion directory for the ANUGA Inundation 
-Software Development project conducted by
-
-Stephen Roberts (ANU)
-Ole Nielsen (GA)
-Duncan Gray (GA)
-Jane Sexton (GA)
-Nick Bartzis (GA)
-Jack Kelly (ANU)
-John Jakeman (ANU)
-
-
-This is the top directory for the inundation project source code
-developed at the Risk Assessment Methods Project at Geoscience
-Australia and Mathematical Sciences Institute at the Australian
-National University.
-
-
-Copyright 2004, 2005, 2006  
-Ole Nielsen, Stephen Roberts, Duncan Gray, Jane Sexton
-
-
-PREREQUISITES
-
-python 2.3 or later
-python-numeric
-python-dev (Interestingly, numeric seems to be installed as well)
-python-scientific (or maybe only python-netcdf)
- (Remember to put netcdf.dll somewhere so the PATH - e.g. in C:\bin)
-
-A C compiler such as gcc (from GNU in case of Linux and MinGW in case of Windows)
-
-RECOMMENDED
-psyco
-visual python
-matplotlib (pylab) for quality 2d plotting
-weave?
-
-
-INSTALLATION
-
-In directory anuga:
-
-  python test_all.py
-  
-
-PATH
-
-
-PATH=C:\Python24;C:\MinGW\bin;C:\Program Files\anuga_viewer
-
-It is assumed that the root directory for all anugu modules is on the pythonpath, e.g.
-PYTHONPATH=V:\home\onielsen\anuga_core\source
-Alternatively this directory should be copied to the python site_packages directory 
-  
-
-  
-  
-LINKS  
-    Python: http://www.python.org
-    Visual Python: http://vpython.org/
-    Python NetCDF Interface: http://www-md.fsl.noaa.gov/eft/developer/netCDFPythonInterface.html    
-    Psyco: http://psyco.sourceforge.net/index.html
-
-
-LICENSE
-    see LICENSE.txt
-    
-
Index: /trunk/anuga_core/source/anuga/damage_modelling/inundation_damage.py
===================================================================
--- /trunk/anuga_core/source/anuga/damage_modelling/inundation_damage.py	(revision 8815)
+++ /trunk/anuga_core/source/anuga/damage_modelling/inundation_damage.py	(revision 8816)
@@ -6,5 +6,6 @@
 import os
 from math import sqrt
-from Scientific.Functions.Interpolation import InterpolatingFunction
+#from Scientific.Functions.Interpolation import InterpolatingFunction
+from scipy.interpolate import interp1d
 from random import choice
 
@@ -208,5 +209,6 @@
     STRUCT_COLLAPSED_TITLE = "STRUCT_COLLAPSED"#"collapsed structure if 1"
     STRUCT_INUNDATED_TITLE = "STRUCT_INUNDATED"#"inundated structure if 1"
-    double_brick_damage_array = num.array([[-kinds.default_float_kind.MAX, 0.0],
+    double_brick_damage_array = num.array([#[-kinds.default_float_kind.MAX, 0.0],
+                                           [-1000.0, 0.0],
                                            [0.0-depth_epsilon, 0.0],
                                            [0.0,0.016],
@@ -218,10 +220,14 @@
                                            [2.0,0.587],
                                            [2.5,0.647],
-                                           [kinds.default_float_kind.MAX,64.7]])
-    double_brick_damage_curve = InterpolatingFunction( \
-        (num.ravel(double_brick_damage_array[:,0:1]),),
-        num.ravel(double_brick_damage_array[:,1:]))
-    
-    brick_veeer_damage_array = num.array([[-kinds.default_float_kind.MAX, 0.0],
+                                           [1000.0, 64.7]
+                                           #[kinds.default_float_kind.MAX,64.7]
+                                           ])
+    #double_brick_damage_curve = InterpolatingFunction( \
+    #    (num.ravel(double_brick_damage_array[:,0:1]),),
+    #    num.ravel(double_brick_damage_array[:,1:]))
+    double_brick_damage_curve = interp1d(double_brick_damage_array[:,0],double_brick_damage_array[:,1])
+    
+    brick_veeer_damage_array = num.array([#[-kinds.default_float_kind.MAX, 0.0],
+                                          [-1000.0,0.0],
                                           [0.0-depth_epsilon, 0.0],
                                           [0.0,0.016],
@@ -233,13 +239,19 @@
                                           [2.0,0.633],
                                           [2.5,0.694],
-                                          [kinds.default_float_kind.MAX,69.4]])
-    brick_veeer_damage_curve = InterpolatingFunction( \
-        (num.ravel(brick_veeer_damage_array[:,0:1]),),
-        num.ravel(brick_veeer_damage_array[:,1:]))
+                                          [1000.0,69.4]
+                                          #[kinds.default_float_kind.MAX,69.4]
+                                          ])
+    #brick_veeer_damage_curve = InterpolatingFunction( \
+    #    (num.ravel(brick_veeer_damage_array[:,0:1]),),
+    #    num.ravel(brick_veeer_damage_array[:,1:]))
+
+    brick_veeer_damage_curve = interp1d(brick_veeer_damage_array[:,0],brick_veeer_damage_array[:,1])
+
     struct_damage_curve = {'Double Brick':double_brick_damage_curve,
                            'Brick Veneer':brick_veeer_damage_curve}
     default_struct_damage_curve = brick_veeer_damage_curve
 
-    contents_damage_array = num.array([[-kinds.default_float_kind.MAX, 0.0],
+    contents_damage_array = num.array([#[-kinds.default_float_kind.MAX, 0.0],
+                                       [-1000.0,0.0],
                                        [0.0-depth_epsilon, 0.0],
                                        [0.0,0.013],
@@ -250,9 +262,12 @@
                                        [1.5,0.976],
                                        [2.0,0.986],
-                                       [kinds.default_float_kind.MAX,98.6]])
-    contents_damage_curve = InterpolatingFunction( \
-        (num.ravel(contents_damage_array[:,0:1]),),
-        num.ravel(contents_damage_array[:,1:]))
-
+                                       [1000.0,98.6]
+                                       #[kinds.default_float_kind.MAX,98.6]
+                                       ])
+    #contents_damage_curve = InterpolatingFunction( \
+    #    (num.ravel(contents_damage_array[:,0:1]),),
+    #    num.ravel(contents_damage_array[:,1:]))
+
+    contents_damage_curve = interp1d(contents_damage_array[:,0],contents_damage_array[:,1])
     #building collapse probability
     # inundation depth above ground floor, m
Index: /trunk/anuga_core/source/anuga/test_all.py
===================================================================
--- /trunk/anuga_core/source/anuga/test_all.py	(revision 8815)
+++ /trunk/anuga_core/source/anuga/test_all.py	(revision 8816)
@@ -33,5 +33,5 @@
 
 # Directories that should not be searched for test files.
-exclude_dirs = ['shallow_water_balanced' , 'damage_modelling', # Special requirements
+exclude_dirs = ['shallow_water_balanced' , #'damage_modelling', # Special requirements
                 '.svn',          # subversion
                 'props', 'wcprops', 'prop-base', 'text-base', 'tmp']
@@ -197,4 +197,17 @@
     from optparse import OptionParser
 
+    import os
+    for file in os.listdir('.'):
+        if file.endswith('.sww') or\
+                file.endswith('.msh') or\
+                file.endswith('.csv') or\
+                file.endswith('.asc') or\
+                file.endswith('.prj') or\
+                file.endswith('.tsh') or\
+                file.endswith('.sts') or\
+                file.endswith('.tms') or\
+                file.endswith('.txt'):
+            os.remove(file)
+
     check_anuga_import()
 
@@ -238,4 +251,20 @@
         #os.remove(filename)
     
-    #if sys.platform == 'win32':
-    #    raw_input('Press the RETURN key')
+
+
+    import os
+    for file in os.listdir('.'):
+        if file.endswith('.sww') or\
+                file.endswith('.msh') or\
+                file.endswith('.csv') or\
+                file.endswith('.asc') or\
+                file.endswith('.prj') or\
+                file.endswith('.tsh') or\
+                file.endswith('.sts') or\
+                file.endswith('.tms') or\
+                file.endswith('.txt'):
+            try:
+                os.remove(file)
+            except:
+                pass
+            