Index: /trunk/anuga_core/source/anuga/LICENSE.txt
===================================================================
--- /trunk/anuga_core/source/anuga/LICENSE.txt	(revision 8817)
+++ /trunk/anuga_core/source/anuga/LICENSE.txt	(revision 8817)
@@ -0,0 +1,54 @@
+=======================================	
+ANUGA Hydrodynamic Inundation Modelling
+=======================================	
+
+
+Copyright 2004, 2005, 2006, 2007, 2008, 2009, 2010 Australian National University and Geoscience Australia. All rights reserved.
+
+
+Permission to use, copy, modify, and distribute this software for any
+purpose without fee is hereby granted under the terms of the GNU
+General Public License as published by the Free Software Foundation;
+either version 2 of the License, or (at your option) any later
+version, provided that this entire notice is included in all copies
+of any software which is or includes a copy or modification of this
+software and in all copies of the supporting documentation for such
+software.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License (http://www.gnu.org/copyleft/gpl.html)
+for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+
+
+
+This work was produced at Geoscience Australia and the Australian
+National University funded by the Commonwealth of Australia. Neither
+the Australian Government, the Australian National University,
+Geoscience Australia nor any of their employees, makes any warranty,
+express or implied, or assumes any liability or responsibility for
+the accuracy, completeness, or usefulness of any information,
+apparatus, product, or process disclosed, or represents that its use
+would not infringe privately-owned rights. Reference herein to any
+specific commercial products, process, or service by trade name,
+trademark, manufacturer, or otherwise, does not necessarily
+constitute or imply its endorsement, recommendation, or favoring by
+the Australian Government, Geoscience Australia or the Australian
+National University.  The views and opinions of authors expressed
+herein do not necessarily state or reflect those of the Australian
+Government, Geoscience Australia or the Australian National
+University, and shall not be used for advertising or product
+endorsement purposes.
+
+
+This document does not convey a warranty, express or implied,
+of merchantability or fitness for a particular purpose.
+
+
+
+
Index: /trunk/anuga_core/source/anuga/README.txt
===================================================================
--- /trunk/anuga_core/source/anuga/README.txt	(revision 8817)
+++ /trunk/anuga_core/source/anuga/README.txt	(revision 8817)
@@ -0,0 +1,69 @@
+This is the root-Subversion directory for the ANUGA Inundation 
+Software Development project conducted by
+
+Stephen Roberts (ANU)
+Ole Nielsen (GA)
+Duncan Gray (GA)
+Jane Sexton (GA)
+Nick Bartzis (GA)
+Jack Kelly (ANU)
+John Jakeman (ANU)
+
+
+This is the top directory for the inundation project source code
+developed at the Risk Assessment Methods Project at Geoscience
+Australia and Mathematical Sciences Institute at the Australian
+National University.
+
+
+Copyright 2004, 2005, 2006  
+Ole Nielsen, Stephen Roberts, Duncan Gray, Jane Sexton
+
+
+PREREQUISITES
+
+python 2.3 or later
+python-numeric
+python-dev (Interestingly, numeric seems to be installed as well)
+python-scientific (or maybe only python-netcdf)
+ (Remember to put netcdf.dll somewhere so the PATH - e.g. in C:\bin)
+
+A C compiler such as gcc (from GNU in case of Linux and MinGW in case of Windows)
+
+RECOMMENDED
+psyco
+visual python
+matplotlib (pylab) for quality 2d plotting
+weave?
+
+
+INSTALLATION
+
+In directory anuga:
+
+  python test_all.py
+  
+
+PATH
+
+
+PATH=C:\Python24;C:\MinGW\bin;C:\Program Files\anuga_viewer
+
+It is assumed that the root directory for all anugu modules is on the pythonpath, e.g.
+PYTHONPATH=V:\home\onielsen\anuga_core\source
+Alternatively this directory should be copied to the python site_packages directory 
+  
+
+  
+  
+LINKS  
+    Python: http://www.python.org
+    Visual Python: http://vpython.org/
+    Python NetCDF Interface: http://www-md.fsl.noaa.gov/eft/developer/netCDFPythonInterface.html    
+    Psyco: http://psyco.sourceforge.net/index.html
+
+
+LICENSE
+    see LICENSE.txt
+    
+