Index: /trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/quantity.py
===================================================================
--- /trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/quantity.py	(revision 8819)
+++ /trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/quantity.py	(revision 8820)
@@ -1556,11 +1556,5 @@
 # Prepare the C extensions.
 ######
-
-from anuga.utilities import compile
-
-if compile.can_use_C_extension('quantity_ext.c'):
-    # Underlying C implementations can be accessed
-
-    from quantity_ext import \
+from quantity_ext import \
          average_vertex_values,\
          backup_centroid_values,\
@@ -1582,7 +1576,2 @@
          set_vertex_values_c, \
          update
-else:
-    msg = 'C implementations could not be accessed by %s.\n ' % __file__
-    msg += 'Make sure compile_all.py has been run as described in '
-    msg += 'the ANUGA installation guide.'
-    raise Exception(msg)
Index: /trunk/anuga_core/source/anuga/caching/caching.py
===================================================================
--- /trunk/anuga_core/source/anuga/caching/caching.py	(revision 8819)
+++ /trunk/anuga_core/source/anuga/caching/caching.py	(revision 8820)
@@ -1114,20 +1114,6 @@
   from anuga.fit_interpolate.general_fit_interpolate import FitInterpolate
   
-  # Setup for quad_tree extension
-  from anuga.utilities import compile
-  if compile.can_use_C_extension('quad_tree_ext.c'):
-      import quad_tree_ext
-  else:
-      msg = "C implementation of quad tree extension not avaliable"
-      raise Exception(msg)
-
-  # Setup for sparse_matrix extension
-  from anuga.utilities import compile
-  if compile.can_use_C_extension('sparse_matrix_ext.c'):
-      import sparse_matrix_ext
-  else:
-      msg = "C implementation of sparse_matrix extension not avaliable"
-      raise Exception(msg)
-
+  import quad_tree_ext
+  import sparse_matrix_ext
   from anuga.geometry.aabb import AABB
 
Index: /trunk/anuga_core/source/anuga/file_conversion/asc2dem.py
===================================================================
--- /trunk/anuga_core/source/anuga/file_conversion/asc2dem.py	(revision 8819)
+++ /trunk/anuga_core/source/anuga/file_conversion/asc2dem.py	(revision 8820)
@@ -192,16 +192,22 @@
 
     #Store data
-    n = len(lines[6:])
-    for i, line in enumerate(lines[6:]):
-        fields = line.split()
-        if verbose and i % ((n+10)/10) == 0:
-            log.critical('Processing row %d of %d' % (i, nrows))
-           
-        if len(fields) != ncols:
-            msg = 'Wrong number of columns in file "%s" line %d\n' % (name_in, i)
-            msg += 'I got %d elements, but there should have been %d\n' % (len(fields), ncols)
-            raise Exception, msg
-
-        elevation[i, :] = num.array([float(x) for x in fields])
+    import numpy
+
+    datafile = open(name_in)
+    elevation[:,:] = numpy.loadtxt(datafile, skiprows=6)
+    datafile.close()
+
+#    n = len(lines[6:])
+#    for i, line in enumerate(lines[6:]):
+#        fields = line.split()
+#        if verbose and i % ((n+10)/10) == 0:
+#            log.critical('Processing row %d of %d' % (i, nrows))
+#
+#        if len(fields) != ncols:
+#            msg = 'Wrong number of columns in file "%s" line %d\n' % (name_in, i)
+#            msg += 'I got %d elements, but there should have been %d\n' % (len(fields), ncols)
+#            raise Exception, msg
+#
+#        elevation[i, :] = num.array([float(x) for x in fields])
 
     fid.close()
Index: /trunk/anuga_core/source/anuga/geometry/polygon.py
===================================================================
--- /trunk/anuga_core/source/anuga/geometry/polygon.py	(revision 8819)
+++ /trunk/anuga_core/source/anuga/geometry/polygon.py	(revision 8820)
@@ -1116,20 +1116,13 @@
 ################################################################################
 
-from anuga.utilities import compile
-if compile.can_use_C_extension('polygon_ext.c'):
-    # Underlying C implementations can be accessed
-    from polygon_ext import _point_on_line
-    from polygon_ext import _separate_points_by_polygon
-    from polygon_ext import _interpolate_polyline    
-    from polygon_ext import _polygon_overlap
-    from polygon_ext import _line_intersect
-    from polygon_ext import _is_inside_triangle        
-    #from polygon_ext import _intersection
-
-else:
-    ERROR_MSG = 'C implementations could not be accessed by %s.\n ' % __file__
-    ERROR_MSG += 'Make sure compile_all.py has been run as described in '
-    ERROR_MSG += 'the ANUGA installation guide.'
-    raise Exception(ERROR_MSG)
+from polygon_ext import _point_on_line
+from polygon_ext import _separate_points_by_polygon
+from polygon_ext import _interpolate_polyline    
+from polygon_ext import _polygon_overlap
+from polygon_ext import _line_intersect
+from polygon_ext import _is_inside_triangle        
+#from polygon_ext import _intersection
+
+
 
 
Index: /trunk/anuga_core/source/anuga/shallow_water/boundaries.py
===================================================================
--- /trunk/anuga_core/source/anuga/shallow_water/boundaries.py	(revision 8819)
+++ /trunk/anuga_core/source/anuga/shallow_water/boundaries.py	(revision 8820)
@@ -29,14 +29,15 @@
 import anuga.utilities.log as log
      
-
-from anuga.utilities import compile
-if compile.can_use_C_extension('shallow_water_ext.c'):
-    # Underlying C implementations can be accessed
-    from shallow_water_ext import rotate
-else:
-    msg = 'C implementations could not be accessed by %s.\n ' % __file__
-    msg += 'Make sure compile_all.py has been run as described in '
-    msg += 'the ANUGA installation guide.'
-    raise Exception, msg
+from shallow_water_ext import rotate
+
+#from anuga.utilities import compile
+#if compile.can_use_C_extension('shallow_water_ext.c'):
+#    # Underlying C implementations can be accessed
+#    from shallow_water_ext import rotate
+#else:
+#    msg = 'C implementations could not be accessed by %s.\n ' % __file__
+#    msg += 'Make sure compile_all.py has been run as described in '
+#    msg += 'the ANUGA installation guide.'
+#    raise Exception, msg
 
 
Index: /trunk/anuga_core/source/anuga/utilities/cg_solve.py
===================================================================
--- /trunk/anuga_core/source/anuga/utilities/cg_solve.py	(revision 8819)
+++ /trunk/anuga_core/source/anuga/utilities/cg_solve.py	(revision 8820)
@@ -10,12 +10,8 @@
 
 # Setup for C conjugate gradient solver
-from anuga.utilities import compile
-if compile.can_use_C_extension('cg_ext.c'):
-    from cg_ext import cg_solve_c
-    from cg_ext import cg_solve_c_precon
-    from cg_ext import jacobi_precon_c
-else: 
-    msg = "C implementation of conjugate gradient (cg_ext.c) not avalaible"
-    raise Exception(msg)
+from cg_ext import cg_solve_c
+from cg_ext import cg_solve_c_precon
+from cg_ext import jacobi_precon_c
+
 
 class Stats:
Index: /trunk/anuga_core/source/anuga/utilities/numerical_tools.py
===================================================================
--- /trunk/anuga_core/source/anuga/utilities/numerical_tools.py	(revision 8819)
+++ /trunk/anuga_core/source/anuga/utilities/numerical_tools.py	(revision 8820)
@@ -389,10 +389,5 @@
 #Initialise module
 
-from anuga.utilities import compile
-if compile.can_use_C_extension('util_ext.c'):
-    from util_ext import gradient, gradient2
-else:
-    gradient = gradient_python
-    gradient2 = gradient2_python    
+from util_ext import gradient, gradient2
 
 
Index: /trunk/anuga_core/source/anuga/utilities/sparse.py
===================================================================
--- /trunk/anuga_core/source/anuga/utilities/sparse.py	(revision 8819)
+++ /trunk/anuga_core/source/anuga/utilities/sparse.py	(revision 8820)
@@ -327,8 +327,5 @@
 
 # Setup for C extensions
-from anuga.utilities import compile
-if compile.can_use_C_extension('sparse_ext.c'):
-    # Access underlying c implementations
-    from sparse_ext import csr_mv
+from sparse_ext import csr_mv
 
 