Index: trunk/anuga_work/development/gareth/tests/dam_break/plotme.py
===================================================================
--- trunk/anuga_work/development/gareth/tests/dam_break/plotme.py	(revision 8774)
+++ trunk/anuga_work/development/gareth/tests/dam_break/plotme.py	(revision 8865)
@@ -9,5 +9,5 @@
 p2_st=util.get_centroids(p_st)
 
-p_dev = util.get_output('dam_break_20130320_001049/dam_break.sww', 0.001)
+p_dev = util.get_output('dam_break_20130504_145918/dam_break.sww', 0.001)
 p2_dev=util.get_centroids(p_dev, velocity_extrapolation=True)
 
Index: trunk/anuga_work/development/gareth/tests/runup/runup.py
===================================================================
--- trunk/anuga_work/development/gareth/tests/runup/runup.py	(revision 8774)
+++ trunk/anuga_work/development/gareth/tests/runup/runup.py	(revision 8865)
@@ -34,10 +34,12 @@
 #------------------
 
+scale_me=100.0
+
 def topography(x,y):
-	return -x/2 #+0.05*numpy.sin((x+y)*50.0) #+0.1*(numpy.random.rand(len(x)) -0.5)       # Linear bed slope + small random perturbation 
+	return -x/2*scale_me #+0.05*numpy.sin((x+y)*50.0) #+0.1*(numpy.random.rand(len(x)) -0.5)       # Linear bed slope + small random perturbation 
 
 def stagefun(x,y):
-    stg=-0.2*(x<0.5) -0.1*(x>=0.5)
-    #stg=-0.2 # Stage
+    #stg=(-0.2*(x<0.5) -0.1*(x>=0.5))*scale_me
+    stg=-0.2*scale_me # Stage
     #topo=topography(x,y) #Bed
     return stg #*(stg>topo) + topo*(stg<=topo)
@@ -55,5 +57,5 @@
 Br=anuga.Reflective_boundary(domain)            # Solid reflective wall
 Bt=anuga.Transmissive_boundary(domain)          # Continue all values of boundary -- not used in this example
-Bd=anuga.Dirichlet_boundary([-0.2,0.,0.])       # Constant boundary values -- not used in this example
+Bd=anuga.Dirichlet_boundary([-0.2*scale_me,0.,0.])       # Constant boundary values -- not used in this example
 #Bw=anuga.Time_boundary(domain=domain,
 #	f=lambda t: [(0.0*sin(t*2*pi)-0.1)*exp(-t)-0.1,0.0,0.0]) # Time varying boundary -- get rid of the 0.0 to do a runup.
Index: trunk/anuga_work/development/gareth/tests/runup_sinusoid/runup_sinusoid.py
===================================================================
--- trunk/anuga_work/development/gareth/tests/runup_sinusoid/runup_sinusoid.py	(revision 8774)
+++ trunk/anuga_work/development/gareth/tests/runup_sinusoid/runup_sinusoid.py	(revision 8865)
@@ -24,16 +24,19 @@
 domain=Domain(points,vertices,boundary)    # Create Domain
 domain.set_name('runup_sinusoid_v2')                         # Output to file runup.sww
-
+#domain.set_timestepping_method('euler')
 #------------------
 # Define topography
 #------------------
 scale_me=1.0
+boundary_ws=-0.1
+init_ws=-0.2
+bumpiness=10. # Higher = shorter wavelength oscillations in topography
 #domain.minimum_allowed_height=domain.minimum_allowed_height*scale_me # Seems needed to make the algorithms behave
 
 def topography(x,y):
-	return (-x/2.0 +0.05*numpy.sin((x+y)*50.0))*scale_me
+	return (-x/2.0 +0.05*numpy.sin((x+y)*bumpiness))*scale_me
 
 def stagefun(x,y):
-    stge=-0.2*scale_me #+0.1*(x>0.9) 
+    stge=init_ws*scale_me# +0.1*(x>0.9)*scale_me 
     #topo=topography(x,y) 
     return stge#*(stge>topo) + (topo)*(stge<=topo)
@@ -41,5 +44,5 @@
 domain.set_quantity('elevation',topography)     # Use function for elevation
 domain.get_quantity('elevation').smooth_vertex_values() 
-domain.set_quantity('friction',0.03)             # Constant friction
+domain.set_quantity('friction',0.00)             # Constant friction
 
 #def frict_change(x,y):
@@ -64,5 +67,6 @@
 Bd=anuga.Dirichlet_boundary([-0.1*scale_me,0.,0.])       # Constant boundary values -- not used in this example
 def waveform(t):
-    return -0.1 #(0.0*sin(t*2*pi)-0.1)*exp(-t)-0.1
+    return boundary_ws*scale_me
+    #return -0.2*scale_me #-0.1 #(0.0*sin(t*2*pi)-0.1)*exp(-t)-0.1
 Bt2=anuga.Transmissive_n_momentum_zero_t_momentum_set_stage_boundary(domain,waveform)
 #Bw=anuga.Time_boundary(domain=domain,
@@ -78,7 +82,7 @@
 #------------------------------
 
-for t in domain.evolve(yieldstep=0.200,finaltime=40.00):
+for t in domain.evolve(yieldstep=0.2,finaltime=120.00):
     print domain.timestepping_statistics()
-    print domain.boundary_flux_integral
+    #print domain.boundary_flux_integral
     xx = domain.quantities['xmomentum'].centroid_values
     yy = domain.quantities['ymomentum'].centroid_values
@@ -88,7 +92,7 @@
     vv = ( (xx/dd)**2 + (yy/dd)**2)**0.5
     vv = vv*(dd>1.0e-03)
-    print 'Peak velocity is: ', vv.max(), vv.argmax()
+    print 'Peak velocity is: ', vv.max(), vv.argmax(), dd[vv.argmax()]
     print 'Volume is', sum(dd_raw*domain.areas)    
-    print 'Volume less flux int', sum(dd_raw*domain.areas) - domain.boundary_flux_integral
+    #print 'Volume less flux int', sum(dd_raw*domain.areas) - domain.boundary_flux_integral
 
 
Index: trunk/anuga_work/development/gareth/tests/shallow_steep_slope/channel_SU_sparse.py
===================================================================
--- trunk/anuga_work/development/gareth/tests/shallow_steep_slope/channel_SU_sparse.py	(revision 8774)
+++ trunk/anuga_work/development/gareth/tests/shallow_steep_slope/channel_SU_sparse.py	(revision 8865)
@@ -36,5 +36,5 @@
 #------------------------------------------------------------------------------
 def topography(x, y):
-	return -x/10. #+ 1.*(numpy.sin(x/10.) +abs(y-50.)/10.) -0.*(x>80.) # linear bed slope
+	return -x/10.  + 1.*(numpy.sin(x/10.) +abs(y-50.)/10.) -0.*(x>80.) # linear bed slope
 
 def stagetopo(x,y):